BpGraphCopy< From, To > Class Template Reference

- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members | Public Member Functions
BpGraphCopy< From, To > Class Template Reference
Basic Graph Utilities

## Detailed Description

### template<typename From, typename To>
class lemon::BpGraphCopy< From, To >

Class to copy a bipartite graph to another graph (duplicate a graph). The simplest way of using it is through the `bpGraphCopy()` function.

This class not only make a copy of a bipartite graph, but it can create references and cross references between the nodes, edges and arcs of the two graphs, and it can copy maps for using with the newly created graph.

To make a copy from a graph, first an instance of BpGraphCopy should be created, then the data belongs to the graph should assigned to copy. In the end, the `run()` member should be called.

The next code copies a graph with several data:

* BpGraphCopy<OrigBpGraph, NewBpGraph> cg(orig_graph, new_graph);
* // Create references for the nodes
* OrigBpGraph::NodeMap<NewBpGraph::Node> nr(orig_graph);
* cg.nodeRef(nr);
* // Create cross references (inverse) for the edges
* NewBpGraph::EdgeMap<OrigBpGraph::Edge> ecr(new_graph);
* cg.edgeCrossRef(ecr);
* // Copy a red node map
* OrigBpGraph::RedNodeMap<double> ormap(orig_graph);
* NewBpGraph::RedNodeMap<double> nrmap(new_graph);
* cg.redNodeMap(ormap, nrmap);
* // Copy a node
* OrigBpGraph::Node on;
* NewBpGraph::Node nn;
* cg.node(on, nn);
* // Execute copying
* cg.run();
*

`#include <lemon/core.h>`

## Public Member Functions
| BpGraphCopy (const From &from, To &to)
| Constructor of BpGraphCopy. More...
| ~BpGraphCopy ()
| Destructor of BpGraphCopy. More...
template<typename NodeRef >
BpGraphCopy & | nodeRef (NodeRef &map)
| Copy the node references into the given map. More...
template<typename NodeCrossRef >
BpGraphCopy & | nodeCrossRef (NodeCrossRef &map)
| Copy the node cross references into the given map. More...
template<typename FromMap , typename ToMap >
BpGraphCopy & | nodeMap (const FromMap &map, ToMap &tmap)
| Make a copy of the given node map. More...
BpGraphCopy & | node (const Node &node, TNode &tnode)
| Make a copy of the given node. More...
template<typename RedRef >
BpGraphCopy & | redRef (RedRef &map)
| Copy the red node references into the given map. More...
template<typename RedCrossRef >
BpGraphCopy & | redCrossRef (RedCrossRef &map)
| Copy the red node cross references into the given map. More...
template<typename FromMap , typename ToMap >
BpGraphCopy & | redNodeMap (const FromMap &map, ToMap &tmap)
| Make a copy of the given red node map. More...
BpGraphCopy & | redNode (const RedNode &node, TRedNode &tnode)
| Make a copy of the given red node. More...
template<typename BlueRef >
BpGraphCopy & | blueRef (BlueRef &map)
| Copy the blue node references into the given map. More...
template<typename BlueCrossRef >
BpGraphCopy & | blueCrossRef (BlueCrossRef &map)
| Copy the blue node cross references into the given map. More...
template<typename FromMap , typename ToMap >
BpGraphCopy & | blueNodeMap (const FromMap &map, ToMap &tmap)
| Make a copy of the given blue node map. More...
BpGraphCopy & | blueNode (const BlueNode &node, TBlueNode &tnode)
| Make a copy of the given blue node. More...
template<typename ArcRef >
BpGraphCopy & | arcRef (ArcRef &map)
| Copy the arc references into the given map. More...
template<typename ArcCrossRef >
BpGraphCopy & | arcCrossRef (ArcCrossRef &map)
| Copy the arc cross references into the given map. More...
template<typename FromMap , typename ToMap >
BpGraphCopy & | arcMap (const FromMap &map, ToMap &tmap)
| Make a copy of the given arc map. More...
BpGraphCopy & | arc (const Arc &arc, TArc &tarc)
| Make a copy of the given arc. More...
template<typename EdgeRef >
BpGraphCopy & | edgeRef (EdgeRef &map)
| Copy the edge references into the given map. More...
template<typename EdgeCrossRef >
BpGraphCopy & | edgeCrossRef (EdgeCrossRef &map)
| Copy the edge cross references into the given map. More...
template<typename FromMap , typename ToMap >
BpGraphCopy & | edgeMap (const FromMap &map, ToMap &tmap)
| Make a copy of the given edge map. More...
BpGraphCopy & | edge (const Edge &edge, TEdge &tedge)
| Make a copy of the given edge. More...
void | run ()
| Execute copying. More...

## Constructor & Destructor Documentation

BpGraphCopy | ( | const From & | from,
|  | To & | to
| ) |  |
| inline

Constructor of BpGraphCopy for copying the content of the `from` graph into the `to` graph.

~BpGraphCopy | ( |  | ) |
| inline

Destructor of BpGraphCopy.

## Member Function Documentation

BpGraphCopy& nodeRef | ( | NodeRef & | map | ) |
| inline

This function copies the node references into the given map. The parameter should be a map, whose key type is the Node type of the source graph, while the value type is the Node type of the destination graph.

BpGraphCopy& nodeCrossRef | ( | NodeCrossRef & | map | ) |
| inline

This function copies the node cross references (reverse references) into the given map. The parameter should be a map, whose key type is the Node type of the destination graph, while the value type is the Node type of the source graph.

BpGraphCopy& nodeMap | ( | const FromMap & | map,
|  | ToMap & | tmap
| ) |  |
| inline

This function makes a copy of the given node map for the newly created graph. The key type of the new map `tmap` should be the Node type of the destination graph, and the key type of the original map `map` should be the Node type of the source graph.

BpGraphCopy& node | ( | const Node & | node,
|  | TNode & | tnode
| ) |  |
| inline

This function makes a copy of the given node.

BpGraphCopy& redRef | ( | RedRef & | map | ) |
| inline

This function copies the red node references into the given map. The parameter should be a map, whose key type is the Node type of the source graph with the red item set, while the value type is the Node type of the destination graph.

BpGraphCopy& redCrossRef | ( | RedCrossRef & | map | ) |
| inline

This function copies the red node cross references (reverse references) into the given map. The parameter should be a map, whose key type is the Node type of the destination graph with the red item set, while the value type is the Node type of the source graph.

BpGraphCopy& redNodeMap | ( | const FromMap & | map,
|  | ToMap & | tmap
| ) |  |
| inline

This function makes a copy of the given red node map for the newly created graph. The key type of the new map `tmap` should be the Node type of the destination graph with the red items, and the key type of the original map `map` should be the Node type of the source graph.

BpGraphCopy& redNode | ( | const RedNode & | node,
|  | TRedNode & | tnode
| ) |  |
| inline

This function makes a copy of the given red node.

BpGraphCopy& blueRef | ( | BlueRef & | map | ) |
| inline

This function copies the blue node references into the given map. The parameter should be a map, whose key type is the Node type of the source graph with the blue item set, while the value type is the Node type of the destination graph.

BpGraphCopy& blueCrossRef | ( | BlueCrossRef & | map | ) |
| inline

This function copies the blue node cross references (reverse references) into the given map. The parameter should be a map, whose key type is the Node type of the destination graph with the blue item set, while the value type is the Node type of the source graph.

BpGraphCopy& blueNodeMap | ( | const FromMap & | map,
|  | ToMap & | tmap
| ) |  |
| inline

This function makes a copy of the given blue node map for the newly created graph. The key type of the new map `tmap` should be the Node type of the destination graph with the blue items, and the key type of the original map `map` should be the Node type of the source graph.

BpGraphCopy& blueNode | ( | const BlueNode & | node,
|  | TBlueNode & | tnode
| ) |  |
| inline

This function makes a copy of the given blue node.

BpGraphCopy& arcRef | ( | ArcRef & | map | ) |
| inline

This function copies the arc references into the given map. The parameter should be a map, whose key type is the Arc type of the source graph, while the value type is the Arc type of the destination graph.

BpGraphCopy& arcCrossRef | ( | ArcCrossRef & | map | ) |
| inline

This function copies the arc cross references (reverse references) into the given map. The parameter should be a map, whose key type is the Arc type of the destination graph, while the value type is the Arc type of the source graph.

BpGraphCopy& arcMap | ( | const FromMap & | map,
|  | ToMap & | tmap
| ) |  |
| inline

This function makes a copy of the given arc map for the newly created graph. The key type of the new map `tmap` should be the Arc type of the destination graph, and the key type of the original map `map` should be the Arc type of the source graph.

BpGraphCopy& arc | ( | const Arc & | arc,
|  | TArc & | tarc
| ) |  |
| inline

This function makes a copy of the given arc.

BpGraphCopy& edgeRef | ( | EdgeRef & | map | ) |
| inline

This function copies the edge references into the given map. The parameter should be a map, whose key type is the Edge type of the source graph, while the value type is the Edge type of the destination graph.

BpGraphCopy& edgeCrossRef | ( | EdgeCrossRef & | map | ) |
| inline

This function copies the edge cross references (reverse references) into the given map. The parameter should be a map, whose key type is the Edge type of the destination graph, while the value type is the Edge type of the source graph.

BpGraphCopy& edgeMap | ( | const FromMap & | map,
|  | ToMap & | tmap
| ) |  |
| inline

This function makes a copy of the given edge map for the newly created graph. The key type of the new map `tmap` should be the Edge type of the destination graph, and the key type of the original map `map` should be the Edge type of the source graph.

BpGraphCopy& edge | ( | const Edge & | edge,
|  | TEdge & | tedge
| ) |  |
| inline

This function makes a copy of the given edge.

void run | ( |  | ) |
| inline

This function executes the copying of the graph along with the copying of the assigned data.